// SingleDoc.cpp 

#include "stdafx.h"
#include "Single.h"

#include "SingleDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////////
// Макрокоманда необходима для динамического создания объектов 
// CSingleDoc
IMPLEMENT_DYNCREATE(CSingleDoc, CDocument)

// Таблица сообщений класса CSingleDoc
BEGIN_MESSAGE_MAP(CSingleDoc, CDocument)
	//{{AFX_MSG_MAP(CSingleDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////////////////////////////
// Конструктор класса CSingleDoc
CSingleDoc::CSingleDoc()
{
	// TODO:
}

// Деструктор класса CSingleDoc
CSingleDoc::~CSingleDoc()
{
}

// Метод OnNewDocument класса CSingleDoc
BOOL CSingleDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: здесь можно выполнить инициализацию 
	// документа

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////
// Сохранение и восстановление документа 
// Метод Serialize класса CSingleDoc
void CSingleDoc::Serialize(CArchive& ar)
{
	int i;		// временная переменная 
	int num;	// количество фигур в документе

	// Сохранение документа
	if(ar.IsStoring())
	{	
		// Определяем количество элементов массива arrayFig
		num = arrayFig.GetSize();

		// Записываем полученное число в файл
		ar << num;

		// Записываем в файл координаты и тип фигур
		for(i=0; i<num; i++)
		{
			// Сохраняем координаты центра фигуры
			ar << arrayFig[i].xyFigCenter;
			// Сохраняем тип фигуры
			ar << arrayFig[i].cType;
		}
	}
	
	// Загрузка документа
	else
	{
		// Считываем количество элементов, составляющих документ
		ar >> num; 

		// Восстанавливаем документ
		for(i=0; i<num; i++)
		{
			CFigure OneFigure; // описание одной фигуры
			
			// Считываем координаты центра фигуры
			ar >> OneFigure.xyFigCenter;
			// Считываем тип фигуры
			ar >> OneFigure.cType;

			// Добавляем описание очередной фигуры в документ
			arrayFig.Add(OneFigure);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// Диагностические методы класса CSingleDoc 
#ifdef _DEBUG

// Метод AssertValid класса CSingleDoc
void CSingleDoc::AssertValid() const
{
	CDocument::AssertValid();
}

// Метод Dump класса CSingleDoc
void CSingleDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

//////////////////////////////////////////////////////////////////////////////////////////////
// Метод DeleteContents класса CSingleDoc
void CSingleDoc::DeleteContents() 
{
	// TODO:
	// Очищаем документ, удаляя все элементы массива arrayFig.
	// Метод RemoveAll определен в классе CArray
	arrayFig.RemoveAll();

	// Вызываем метод DeleteContents базового класса CDocument
	CDocument::DeleteContents();
}
